#include "Util.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include <time.h>
#include "Descida.h"
#include "Util.h"
#include "Arquivos.h"
#include "Estruturas.h"
#include "ILS.h"


float ILS(int n,
         int *s,
         float **d,
         int vezesnivel,
         int ILSmax)
{
    int i, j;
    int nivel = 1,  // nivel de perturbacao
        iter = 0,  // numero corrente de iteracoes
        MelhorIter = 0; // iteracao em que ocorreu a melhor solucao
    int *s_star,
        *s_2l;  // s duas linhas
    float fo, fo_star, fo_2l;
    clock_t inicio_CPU, fim_CPU;

    s_star = cria_vetor(n);
    inicializa_vetor(s_star,n);
    atualiza_vetor(s_star, s, n);
    s_2l = cria_vetor(n);
    inicializa_vetor(s_2l,n);
    fo_star = fo = calcula_fo(n,s,d);

    printf("\nIniciando o ILS com fo = %8.2f\n", fo);
    inicio_CPU = fim_CPU = clock();
    limpa_arquivo("ILSsaida.txt");
    limpa_arquivo("ILSsaidaMelhorfo.txt");

    imprime_fo("ILSsaida.txt", (float)(fim_CPU - inicio_CPU)/CLOCKS_PER_SEC, fo, iter);

    imprime_fo("ILSsaidaMelhorfo.txt", (float)(fim_CPU - inicio_CPU)/CLOCKS_PER_SEC, fo_star, iter);
    while (iter - MelhorIter < ILSmax) {
	iter++;
        // s_2l <-- s
        atualiza_vetor(s_2l, s, n);

        // Repetindo um dado nivel de perturbacao por vezesnivel vezes
        int vezes = 0;
        while (vezes <= vezesnivel){

        // Gerando um vizinho qualquer com um dado nivel de perturbacao
          int ntrocas = 0;
          while (ntrocas < nivel){
            i = random(n);
            do{
              j = random(n);
            }while (i == j);
            int aux = s_2l[i];
            s_2l[i] = s_2l[j];
            s_2l[j] = aux;
            ntrocas++;
          }
          fo_2l = calcula_fo(n,s_2l,d);
	  fim_CPU = clock();
          imprime_fo("ILSsaida.txt", (float)(fim_CPU - inicio_CPU)/CLOCKS_PER_SEC, fo_2l, iter);

          // Aplicando Busca Local sobre a solucao perturbada s_duaslinhas
          fo_2l = descida(n,s_2l,d);

          if (fo_2l < fo_star){
	     atualiza_vetor(s_star, s_2l, n);
             fo_star = fo_2l;
	     atualiza_vetor(s, s_2l, n);
             fo = fo_2l;
             nivel = 1;    // Retornar ao nivel minimo de perturbacao
             printf("fo_star = %8.2f \n",fo_star);
             imprime_fo("ILSsaidaMelhorfo.txt", (float)(fim_CPU - inicio_CPU)/CLOCKS_PER_SEC, fo_star, iter);
             vezes = 0;
             MelhorIter = iter;
          }
          vezes++;
        }
        if (vezes > vezesnivel){
          nivel++;
          printf("Aumentando perturbacao para o nivel %2d \n",nivel);
        }
    }
    fim_CPU = clock();
    imprime_fo("ILSsaida.txt", (float)(fim_CPU - inicio_CPU)/CLOCKS_PER_SEC, fo_2l, iter);
    imprime_fo("ILSsaidaMelhorfo.txt", (float)(fim_CPU - inicio_CPU)/CLOCKS_PER_SEC, fo_star, iter);
    atualiza_vetor(s, s_star, n);
    libera_vetor(s_star);
    libera_vetor(s_2l);
    fo = fo_star;
    return fo;
}


